"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.useQueryRd = void 0;
var client_1 = require("@apollo/client");
/**
 * @description Maps a `useQuery` QueryResult to the appropriate RemoteData discriminant
 * @param d DocumentNode
 * @returns Everything from `QueryResult` with an accompanying `_rd` property wth the RemoteData object
 */
var useQueryRd = function (d) {
    var res = (0, client_1.useQuery)(d);
    if (!res.called) {
        return __assign(__assign({}, res), { _rd: {
                tag: 'Initialized'
            } });
    }
    if (res.loading) {
        return __assign(__assign({}, res), { _rd: {
                tag: 'Pending'
            } });
    }
    if (res.data !== null && res.data !== undefined) {
        return __assign(__assign({}, res), { _rd: {
                tag: 'Success',
                data: res.data
            } });
    }
    if (res.error !== null && res.error !== undefined) {
        return __assign(__assign({}, res), { _rd: {
                tag: 'Failure',
                error: res.error
            } });
    }
    throw new TypeError('RemoteData case not matched');
};
exports.useQueryRd = useQueryRd;
//# sourceMappingURL=index.js.map